﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure.ServiceRuntime;
using System.Text;

namespace WebRole.Controllers
{
    public class HomeController : Controller
    {
        private CloudStorageAccount account { get { return CloudStorageAccount.Parse(RoleEnvironment.GetConfigurationSettingValue("DataConnectionString")); } }
        private CloudBlobContainer incomingContainer { get { return account.CreateCloudBlobClient().GetContainerReference("incoming"); } }
        private CloudBlobContainer publicContainer { get { return account.CreateCloudBlobClient().GetContainerReference("public"); } }
        private CloudQueue incomingQueue { get { return account.CreateCloudQueueClient().GetQueueReference("incoming"); } }

        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Check(string id)
        {
            try
            {
                var blob = publicContainer.GetBlobReference(id);
                blob.FetchAttributes();
                return Json(new { done = true, quarantined = blob.Metadata["quarantined"] == "true", url = blob.Uri.AbsoluteUri });
            }
            catch
            {
                return Json(new { done = false });
            }
        }

        public ActionResult Show(string id)
        {
            ViewBag.id = id;
            return View();
        }

        [HttpPost]
        public ActionResult Submit(string method)
        {
            var guid = Guid.NewGuid().ToString();
            var blob = incomingContainer.GetBlobReference(guid);
            if (method == "file")
            {
                blob.Properties.ContentType = Request.Files[0].ContentType;
                blob.UploadFromStream(Request.Files[0].InputStream);
            }
            else
            {
                string eicar = @"X5O!P%@AP[4\PZX54(P^)7CC)7}$EICAR-STANDARD-ANTIVIRUS-TEST-FILE!$H+H*";
                blob.UploadText(eicar);
            }
            incomingQueue.AddMessage(new CloudQueueMessage(guid));
            return RedirectToAction("show", new { id = guid });
        }
    }
}
