using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.Diagnostics;
using Microsoft.WindowsAzure.ServiceRuntime;
using Microsoft.WindowsAzure.StorageClient;

namespace WebRole
{
    public class WebRole : RoleEntryPoint
    {
        public override bool OnStart()
        {
            var account = CloudStorageAccount.Parse(RoleEnvironment.GetConfigurationSettingValue("DataConnectionString"));
            var blobs = account.CreateCloudBlobClient();
            blobs.GetContainerReference("incoming").CreateIfNotExist();
            blobs.GetContainerReference("quarantined").CreateIfNotExist();
            var container = blobs.GetContainerReference("public");
            if (container.CreateIfNotExist())
            {
                container.SetPermissions(new BlobContainerPermissions { PublicAccess = BlobContainerPublicAccessType.Blob });
            }
            account.CreateCloudQueueClient().GetQueueReference("incoming").CreateIfNotExist();
            return base.OnStart();
        }
    }
}
